#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_StarLotteryRateCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_StarLotteryRateCFG> M_StarLotteryRateCFG::msSingleton(nullptr);

int M_StarLotteryRateCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_StarLotteryRateCFGData* M_StarLotteryRateCFG::GetData(int UpRange)
{
	auto it = mMapData.find(UpRange);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_StarLotteryRateCFGData>& M_StarLotteryRateCFG::GetMapData()
{
	return mMapData;
}

void M_StarLotteryRateCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_StarLotteryRateCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_StarLotteryRateCFGData data;
		data.mUpRange = element->IntAttribute("UpRange");
		data.mDailyRate = element->IntAttribute("DailyRate");
		data.mTotalRate = element->IntAttribute("TotalRate");
		if (mMapData.find(data.mUpRange) != mMapData.end())std::cout <<"data refind:" << data.mUpRange << std::endl;
		assert(mMapData.find(data.mUpRange) == mMapData.end());
		mMapData.insert(std::make_pair(data.mUpRange, data));
		element = element->NextSiblingElement();
	}
}

void M_StarLotteryRateCFG::Load()
{
	Load("../Config/M_StarLotteryRateCFG.xml");
}

M_StarLotteryRateCFG* M_StarLotteryRateCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_StarLotteryRateCFG());
	}
	return msSingleton.get();
}
